// AUTOGENERATED COPYRIGHT HEADER START
// Copyright (C) 2020-2023 Michael Fabian 'Xaymar' Dirks <info@xaymar.com>
// AUTOGENERATED COPYRIGHT HEADER END

//--------------------------------------------------------------------------------//
// THIS FEATURE IS DEPRECATED. SUBMITTED PATCHES WILL BE REJECTED.
//--------------------------------------------------------------------------------//

#pragma once
#include "common.hpp"
#include "handler.hpp"

extern "C" {
#include "warning-disable.hpp"
#include <libavcodec/avcodec.h>
#include "warning-enable.hpp"
}

namespace streamfx::encoder::ffmpeg::handler {
	class amf_h264_handler : public handler {
		public:
		virtual ~amf_h264_handler(){};

		public /*factory*/:
		void adjust_info(ffmpeg_factory* factory, const AVCodec* codec, std::string& id, std::string& name,
						 std::string& codec_id) override;

		void get_defaults(obs_data_t* settings, const AVCodec* codec, AVCodecContext* context, bool hw_encode) override;

		virtual std::string_view get_help_url(const AVCodec* codec) override
		{
			return "https://github.com/Xaymar/obs-StreamFX/wiki/Encoder-FFmpeg-AMF";
		};

		public /*support tests*/:
		bool has_keyframe_support(ffmpeg_factory* instance) override;

		bool is_hardware_encoder(ffmpeg_factory* instance) override;

		bool has_threading_support(ffmpeg_factory* instance) override;

		bool has_pixel_format_support(ffmpeg_factory* instance) override;

		public /*settings*/:
		void get_properties(obs_properties_t* props, const AVCodec* codec, AVCodecContext* context,
							bool hw_encode) override;

		void migrate(obs_data_t* settings, std::uint64_t version, const AVCodec* codec,
					 AVCodecContext* context) override;

		void update(obs_data_t* settings, const AVCodec* codec, AVCodecContext* context) override;

		void override_update(ffmpeg_instance* instance, obs_data_t* settings) override;

		void log_options(obs_data_t* settings, const AVCodec* codec, AVCodecContext* context) override;

		public /*instance*/:

		void override_colorformat(AVPixelFormat& target_format, obs_data_t* settings, const AVCodec* codec,
								  AVCodecContext* context) override;

		private:
		void get_encoder_properties(obs_properties_t* props, const AVCodec* codec);

		void get_runtime_properties(obs_properties_t* props, const AVCodec* codec, AVCodecContext* context);
	};
} // namespace streamfx::encoder::ffmpeg::handler
